/*
 * servletVerificadorFacturas.java
 *
 * Created on 20 de septiembre de 2003, 10:48
 */

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import facturascomun.*;
import ejbfacturas.*;

import javax.naming.*;
import ejbfacturas.*;
import javax.rmi.*;

import java.util.*;

/**
 *
 * @author  Roberto Canales
 * @version
 */
public class servletVerificadorFacturas extends HttpServlet {
    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        
    }
    
    /** Destroys the servlet.
     */
    public void destroy() {
        
    }
    
    private static InitialContext getInitialContext() throws NamingException	
    {		
        Hashtable env = new Hashtable();		
        env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.enterprise.naming.SerialInitContextFactory");
        env.put("java.naming.factory.url.pkgs", "com.sun.enterprise.naming");
        env.put(Context.PROVIDER_URL, "iiop://127.0.0.1:1050");
        
        return new InitialContext(env);	
    }

    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Prueba de EJB Factura</title>");
        out.println("</head>");
        out.println("<body>");
        
        Context contexto = null;
        iFacturasHome miHome = null;
        
       
        try
        {
            contexto = getInitialContext();
            Object objetoGenerico = contexto.lookup("java:comp/env/ejb/gestorfacturas");
            miHome = (iFacturasHome)PortableRemoteObject.narrow(objetoGenerico,iFacturasHome.class);
            
            iFacturas ejbGestorFacturas = miHome.create();
            depura(out,"Nmero de facturas en BBDD = " + ejbGestorFacturas.recuperaNumeroFacturas());
       
            depura(out,"Vamos a insertar un nuevo elemento con EJB CMP");
            ejbGestorFacturas.insertaNuevaFactura(new Factura("73","AdictosAlTrabajo","Consultoria Tecnologica","54332112s", "Calle del Olivo", "28/10/2003", 5644.21));
            ejbGestorFacturas.insertaNuevaFactura(new Factura("22","AdictosAlTrabajo2","Consultoria Tecnologica2","54332112s2", "Calle del Olivo2", "28/12/2003", 5543.21));
            depura(out,"La operacion se ejecuto satisfactoriamente");
        
            
        }
        catch(Exception e)
        {
            depura(out,"Error al gestionar Facturas\n" + e.getMessage());
            e.printStackTrace();
        }
        
        out.println("</body>");
        out.println("</html>");
         
        out.close();
    }
    
    /**
     * 
     */
    void depura(PrintWriter pOut, String sCadena)
    {
        pOut.println("<br>Depuracion: " + sCadena);
        System.out.println("Depuracion: " + sCadena);
    }
    
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    
}
